/* dba2txt.c - dump Palm archive (dba) format
 *
 * This is a sample program using palmlib.
 *
 * Copyright (c) 2002 Tony Aiuto
 *
 */


/*
 * Author: Tony Aiuto (tony@aiu.to)
 *
 * Permission is granted to anyone to use this software for any purpose on
 * any computer system, and to alter it and redistribute it freely, subject
 * to the following restrictions:
 *
 * 1. Neither the authors nor their employers are responsible for
 *    any consequences of the use of this software.
 *
 * 2. The origin of this software must not be misrepresented, either by
 *    explicit claim or by omission.  Credit to the authors must appear
 *    in documentation and sources.
 *
 * 3. Altered versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 *
 * 4. This copyright notice may not be removed or altered.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL TONY AIUTO, HIS CURRENT OR PAST EMPLOYERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


/* Edit History:
 *
 * $Log: dba2txt.cpp $
 * Revision tools_TonyAiuto/6 2002/09/07 05:48:48 TonyAiuto
 * 	add copyright stuff
 * 
 * Wed Sep  4 23:59:18 EDT 2002
 * tony - created
 */


#ifndef lint
static char _copyright[] = "@(#) Copyright (c) 2002, Tony Aiuto";
static char rcsid[] = "@(#) $Id: dba2txt.cpp tools_TonyAiuto/6 2002/09/07 05:48:48 TonyAiuto $";
#endif


#include <stdio.h>

#include "palmlib.h"

static void usage()
{
	fprintf(stderr, "dba2txt file\n");
	exit(1);
}


static void dumpit(FILE *inp, FILE *out)
{
	PalmRead reader(inp);
	int	i;

	reader.loadheader();
	reader.printheader(out);

	for(i = 0; i < reader.getNumEntries(); i++) {
		fprintf(out, "\nItem %d\n", i);

		PalmEntry *e = reader.getEntry();
		if(e != NULL) {
			e->print(&reader, out);
			delete e;
		} else {
			PalmUtil::dumpEntry(&reader, out);
		}
	}
}


main(int argc, char *argv[])
{

	if(argc < 1) {
		usage();
		exit(1);
	}

	FILE *inp = fopen(argv[1], "r");
	if(inp == NULL) {
		fprintf(stderr, "Cannot open %s\n", argv[1]);
		exit(1);
	}

	dumpit(inp, stdout);
}
